'Placed in the Public Domain 5/24/97  John E. Carter
'johnecarter@mindspring.com
'
'requires PowerBasic 2.1 or later to compile
'
'Model 100 de-tokenizer - version 1.0 - 11/27/92
'Converts tokenized BASIC files to ASCII
'Copyright 1992 John E. Carter
'Written for the PowerBASIC Compiler - if you program in BASIC under MS-DOS,
'you should be using PB.
defint a-z
dim tok$(128:255)
tok$(128)=" END "               'array of tokens
tok$(129)=" FOR "
tok$(130)=" NEXT "
tok$(131)=" DATA "
tok$(132)=" INPUT "
tok$(133)=" DIM "
tok$(134)=" READ "
tok$(135)=" LET "
tok$(136)=" GOTO "
tok$(137)=" RUN"
tok$(138)=" IF "
tok$(139)=" RESTORE "
tok$(140)=" GOSUB "
tok$(141)=" RETURN "
tok$(142)=" REM "
tok$(143)=" STOP"
tok$(144)=" WIDTH "
tok$(145)=" ELSE "
tok$(146)=" LINE "
tok$(147)=" EDIT "
tok$(148)=" ERROR "
tok$(149)=" RESUME "
tok$(150)=" OUT"
tok$(151)=" ON "
tok$(152)=" DSKO$ "
tok$(153)=" OPEN "
tok$(154)=" CLOSE "
tok$(155)=" LOAD"
tok$(156)=" MERGE "
tok$(157)=" FILES "
tok$(158)=" SAVE"
tok$(159)=" LFILES "
tok$(160)=" LPRINT "
tok$(161)=" DEF"
tok$(162)=" POKE "
tok$(163)=" PRINT "
tok$(164)=" CONT "
tok$(165)=" LIST "
tok$(166)=" LLIST "
tok$(167)=" CLEAR "
tok$(168)=" CLOAD "
tok$(169)=" CSAVE "
tok$(170)=" TIME$"
tok$(171)=" DATE$"
tok$(172)=" DAY$ "
tok$(173)=" COM "
tok$(174)=" MDM "
tok$(175)=" KEY "
tok$(176)=" CLS "
tok$(177)=" BEEP "
tok$(178)=" SOUND "
tok$(179)=" LCOPY "
tok$(180)=" PSET "
tok$(181)=" PRESET "
tok$(182)=" MOTOR "
tok$(183)=" MAX"
tok$(184)=" POWER "
tok$(185)=" CALL "
tok$(186)=" MENU "
tok$(187)=" IPL "
tok$(188)=" NAME "
tok$(189)=" KILL "
tok$(190)=" SCREEN "
tok$(191)=" NEW "
tok$(192)=" TAB("
tok$(193)=" TO "
tok$(194)=" USING "
tok$(195)=" VARPTR "
tok$(196)=" ERL "
tok$(197)=" ERR "
tok$(198)=" STRING$"
tok$(199)=" INSTR"
tok$(200)=" DSKI$ "
tok$(201)=" INKEY$ "
tok$(202)=" CSRLIN "
tok$(203)=" OFF "
tok$(204)=" HIMEM "
tok$(205)=" THEN "
tok$(206)=" NOT "
tok$(207)=" STEP "
tok$(208)=" + "
tok$(209)=" - "
tok$(210)=" * "
tok$(211)=" / "
tok$(212)=" ^ "
tok$(213)=" AND "
tok$(214)=" OR "
tok$(215)=" XOR "
tok$(216)=" EQV "
tok$(217)=" IMP "
tok$(218)=" MOD "
tok$(219)=" \ "
tok$(220)=" > "
tok$(221)=" = "
tok$(222)=" < "
tok$(223)=" SGN "
tok$(224)=" INT "
tok$(225)=" ABS"
tok$(226)=" FRE"
tok$(227)=" INP "
tok$(228)=" LPOS "
tok$(229)=" POS"
tok$(230)=" SQR"
tok$(231)=" RND "
tok$(232)=" LOG"
tok$(233)=" EXP"
tok$(234)=" COS"
tok$(235)=" SIN"
tok$(236)=" TAN"
tok$(237)=" ATN"
tok$(238)=" PEEK"
tok$(239)=" EOF"
tok$(240)=" LOC "
tok$(241)=" LOF "
tok$(242)=" CINT"
tok$(243)=" CSNG"
tok$(244)=" CDBL"
tok$(245)=" FIX"
tok$(246)=" LEN"
tok$(247)=" STR$"
tok$(248)=" VAL"
tok$(249)=" ASC"
tok$(250)=" CHR$"
tok$(251)=" SPACE$"
tok$(252)=" LEFT$"
tok$(253)=" RIGHT$"
tok$(254)=" MID$"
tok$(255)=" ' "

cls
x$ = "Model 100 BASIC De-tokenizer - Version 1.0"
call center(x$,80)
print x$
x$ = "Copyright 1992 John E. Carter"
call center(x$,80)
print x$
x$="johnecarter@mindspring.com"
call center(x$,80)
print x$
if command$ <> "" then         'if there are command line arguments
  cmd$ = command$
  inf$ = cmd$                  'assume it's a file name
  else
    print
    input "Model 100 file to translate: ";inf$
    if inf$ = "" then end
end if

dotloc = instr(inf$,".")          'does the file have an extension?
if dotloc > 0 then
  otf$ = left$(inf$, dotloc -1)   'chop it off to create output file name
  otf$ = otf$ + ".cxl"            'add output file extension
else
  otf$ = inf$ + ".cxl"            'or just add the extension
end if

k$ = dir$(inf$)                   'check for file
if len(k$) = 0 then               'if not there
  print inf$;" not found"
  end                             'quit
end if

open inf$ for binary as 1         'read it in binary mode
open otf$ for output as 2         'print in ASCII

get$ 1,32750,q$        'nothing larger than this in Model 100 BASIC
'Can your BASIC process a 32,750 character string?

t = 999                           'dummy value
k = 1                             'first position in string

lq = len(q$)                      'get the actual file size

print "Processing ";lq;" bytes from ";inf$;" to ";otf$

'this is the loop that extracts each line's data
while k <= lq                     'as long as we have bytes left
  x$ = ""
  addr! = ascii(mid$(q$,k,1))           'lo byte of address of next line
  incr k
  incr addr!, ascii(mid$(q$,k,1))*256   'hi byte of address of next line
  incr k
  linum! = ascii(mid$(q$,k,1))          'lo byte of line number
  incr k
  incr linum!, ascii(mid$(q$,k,1)) * 256  'hi byte of line number
  incr k
  t$ = mid$(q$,k,1)
  t = ascii(t$)
  while t <> 0                          'line ends with a null
    t$ = mid$(q$,k,1)                   'get one byte
    t = ascii(t$)
    if t > 30 and t < 128 then x$ = x$ + t$   'if printable, add to string
    if t > 127 then x$ = x$ + tok$(t)         'if token, add token text to string
    incr k
    if k > lq then exit loop                  'if done
  wend
  'end of extract loop
  x$ = str$(linum!,5) + " " + x$
  if csrlin > 22 then
    cls
    print "Processing ";lq;" bytes from ";inf$;" to ";otf$
  end if
  print x$                                   'display to screen
  print #2, x$                               'add to output file
wend
close
beep
print:print "DONE"
end

SUB center(x$,ll)
  xl = len(x$)
  pl = (ll -xl)/2
  x$ = space$(pl) + x$
END SUB
